<?php

/**
 * HybridAuth
 * http://hybridauth.sourceforge.net | http://github.com/hybridauth/hybridauth
 * (c) 2009-2015, HybridAuth authors | http://hybridauth.sourceforge.net/licenses.html
 */
// ----------------------------------------------------------------------------------------
//	HybridAuth Config file: http://hybridauth.sourceforge.net/userguide/Configuration.html
// ----------------------------------------------------------------------------------------

GLOBAL $wpd_settings;
$wpc_social_networks = $wpd_settings['wpc_social_networks'];
if (isset($wpc_social_networks['wpc-facebook-app-id']))
    $facebook_app_id = $wpc_social_networks['wpc-facebook-app-id'];
else
    $facebook_app_id = "";
if (isset($wpc_social_networks['wpc-facebook-app-secret']))
    $facebook_app_secret = $wpc_social_networks['wpc-facebook-app-secret'];
else
    $facebook_app_secret = "";
if (isset($wpc_social_networks['wpc-instagram-app-id']))
    $instagram_app_id = $wpc_social_networks['wpc-instagram-app-id'];
else
    $instagram_app_id = "";
if (isset($wpc_social_networks['wpc-instagram-app-secret']))
    $instagram_app_secret = $wpc_social_networks['wpc-instagram-app-secret'];
else
    $instagram_app_secret = "";

return array(
    "base_url" => WPD_URL . '/includes/hybridauth/',
    "providers" => array(
        // openid providers
        "OpenID" => array(
            "enabled" => true,
        ),
        "Yahoo" => array(
            "enabled" => true,
            "keys" => array("id" => "", "secret" => ""),
        ),
        "AOL" => array(
            "enabled" => true,
        ),
        "Google" => array(
            "enabled" => true,
            "keys" => array("id" => "", "secret" => ""),
        ),
        "Facebook" => array(
            "enabled" => true,
            "keys" => array("id" => $facebook_app_id, "secret" => $facebook_app_secret),
            "trustForwarded" => false,
            "scope" => array('user_photos')
        ),
        "Instagram" => array(
            "enabled" => true,
            "keys" => array("id" => $instagram_app_id, "secret" => $instagram_app_secret),
        ),
        "Twitter" => array(
            "enabled" => true,
            "keys" => array("key" => "", "secret" => ""),
            "includeEmail" => false,
        ),
        // windows live
        "Live" => array(
            "enabled" => true,
            "keys" => array("id" => "", "secret" => ""),
        ),
        "LinkedIn" => array(
            "enabled" => true,
            "keys" => array("id" => "", "secret" => ""),
            "fields" => array(),
        ),
        "Foursquare" => array(
            "enabled" => true,
            "keys" => array("id" => "", "secret" => ""),
        ),
    ),
    // If you want to enable logging, set 'debug_mode' to true.
    // You can also set it to
    // - "error" To log only error messages. Useful in production
    // - "info" To log info and error messages (ignore debug messages)
    "debug_mode" => false,
    // Path to file writable by the web server. Required if 'debug_mode' is not false
    "debug_file" => "",
);
